#ifndef BOX_H
#define BOX_H

#include "shape.h"

struct Box: public Shape
{
   BoundingBox box;

   Box(void)
      : box(Vec3f(0,0,0), Vec3f(1,1,1))
   {}

   Box(const Vec3f& xmin,
       const Vec3f& xmax)
      : box(xmin, xmax)
   {}

   virtual bool
   any_intersection(const Ray& ray,
                    float smin,
                    float smax) const;

   virtual bool
   first_intersection(const Ray& ray,
                      float smin,
                      float smax,
                      float& s,
                      Vec3f& normal) const;
   
   virtual BoundingBox
   bounding_box(void) const
   {
      BoundingBox b(box);
      b.enlarge(1e-4);
      return b;
   }

   virtual bool
   contains(const Vec3f& x) const
   { return box.contains(x); }
};

#endif
