#ifndef DIFFUSE_SHADER_H
#define DIFFUSE_SHADER_H

#include "shader.h"
#include "raytracer.h"

struct DiffuseShader: public Shader
{
   Vec3f diffuse_color;

   DiffuseShader(const Vec3f& color)
      : diffuse_color(color)
   {}

   virtual Vec3f
   evaluate(const Ray& ray,
            float s,
            const Vec3f& normal,
            const RayTracer& rt,
            int max_depth) const
   {
      // Here you should add the code to calculate the diffuse colour returned
      // along the ray at the point given by parameter value s where the surface
      // normal is as given. Use the raytracer (rt) to query for how much
      // incident light there is: rt.gather_light()
      // Make sure to flip the normal if it's not facing opposite the ray!
      // For this function, you can ignore max_depth.
      // @@@@@@@@@@@@@@@@
      return diffuse_color; // delete this line once you have it filled in
   }

   virtual Vec3f
   shadow_transmittance(const Shape& shape,
                        const Ray& ray,
                        float smin,
                        float smax) const
   {
      if(shape.any_intersection(ray, smin, smax))
         return Vec3f(0,0,0);
      else
         return Vec3f(1,1,1);
   }
};

#endif
