#ifndef EMISSION_SHADER_H
#define EMISSION_SHADER_H

#include "shader.h"

struct EmissionShader: public Shader
{
   Vec3f emission_color;

   EmissionShader(const Vec3f& color)
      : emission_color(color)
   {}

   virtual Vec3f
   evaluate(const Ray& ray,
            float s,
            const Vec3f& normal,
            const RayTracer& rt,
            int max_depth) const
   { return emission_color; }

   virtual Vec3f
   shadow_transmittance(const Shape& shape,
                        const Ray& ray,
                        float smin,
                        float smax) const
   { return Vec3f(1,1,1); }
};

#endif
