#ifndef MIRROR_SHADER_H
#define MIRROR_SHADER_H

#include "shader.h"
#include "raytracer.h"

struct MirrorShader: public Shader
{
   Vec3f mirror_color;

   MirrorShader(const Vec3f& color)
      : mirror_color(color)
   {}

   virtual Vec3f
   evaluate(const Ray& ray,
            float s,
            const Vec3f& normal,
            const RayTracer& rt,
            int max_depth) const
   {
      // Here you should calculate and return the mirror-reflected colour.
      // That is, compute the reflection secondary ray.

      //@@@@@@@
      // Ray reflection(@@@, @@@);

      // Once you have the secondary ray, the following asks the raytracer
      // for the incoming colour on it, scales that by mirror_color, and
      // returns the result.
      //float s0;
      //return mirror_color*rt.trace_ray(reflection, rt.epsilon,
      //                                 std::numeric_limits<float>::max(), s0,
      //                                 max_depth);
      return mirror_color; // delete this line once you have things filled in
   }

   virtual Vec3f
   shadow_transmittance(const Shape& shape,
                        const Ray& ray,
                        float smin,
                        float smax) const
   {
      if(shape.any_intersection(ray, smin, smax))
         return Vec3f(0,0,0);
      else
         return Vec3f(1,1,1);
   }
};

#endif
