#ifndef NORMAL_SHADER_H
#define NORMAL_SHADER_H

#include "shader.h"
#include "raytracer.h"

struct NormalShader: public Shader
{
   NormalShader(void)
   {}

   virtual Vec3f
   evaluate(const Ray& ray,
            float s,
            const Vec3f& normal,
            const RayTracer& rt,
            int max_depth) const
   {
      return Vec3f(0.5f*(normal[0]+1),
                   0.5f*(normal[1]+1),
                   0.5f*(normal[2]+1));
   }

   virtual Vec3f
   shadow_transmittance(const Shape& shape,
                        const Ray& ray,
                        float smin,
                        float smax) const
   {
      if(shape.any_intersection(ray, smin, smax))
         return Vec3f(0.5f,0.5f,0.5f);
      else
         return Vec3f(1,1,1);
   }
};

#endif
