#ifndef SHADER_H
#define SHADER_H

#include "primitives.h"

struct RayTracer;
struct Shape;

struct Shader
{
   virtual
   ~Shader(void)
   {}

   // calculate the color along the ray
   virtual Vec3f
   evaluate(const Ray& ray,
            float s,
            const Vec3f& normal,
            const RayTracer& rt,
            int max_depth) const = 0;

   // calculate the transmittance through the given ray
   virtual Vec3f
   shadow_transmittance(const Shape& shape,
                        const Ray& ray,
                        float smin,
                        float smax) const = 0;
};

#endif
