#ifndef SPHERE_H
#define SPHERE_H

#include "shape.h"

// a perfect sphere
struct Sphere: public Shape
{
   Vec3f centre;
   float radius;

   Sphere(void) : centre(0,0,0), radius(1)
   {}

   Sphere(const Vec3f& centre_,
          float radius_)
      : centre(centre_), radius(radius_)
   {
      assert(radius>=0);
   }

   virtual bool
   any_intersection(const Ray& ray,
                    float smin,
                    float smax) const;

   virtual bool
   first_intersection(const Ray& ray,
                      float smin,
                      float smax,
                      float& s,
                      Vec3f& normal) const;
   
   virtual BoundingBox
   bounding_box(void) const
   {
      return BoundingBox(centre-Vec3f(radius), centre+Vec3f(radius));
   }

   virtual bool
   contains(const Vec3f& x) const
   { return dist2(x, centre)<=sqr(radius); }
};

#endif
